; ==============================================================================
;	MAINROM SLOT PATCH
;	Copy the value of FCC1h to FFF7h if it was MSX1.
; ------------------------------------------------------------------------------
;	Copyright (C)2020 t.hara
; ==============================================================================

		include		"msxbios.asm"
		include		"msxdos1.asm"
		include		"msxdos2.asm"

		org			0x0100

entry::
		ld			de, msg_version

		; Is this MSX2 or later?
		ld			a, [exbrsa]
		ld			hl, 0x0000
		call		rdslt
		ei
		cp			a, 'C'
		jp			nz, this_is_msx1

		ld			a, [exbrsa]
		ld			hl, 0x0001
		call		rdslt
		ei
		cp			a, 'D'
		jp			nz, this_is_msx1

this_is_msx2_or_later:
		ld			de, msg_detect_msx2
		ld			c, D1F_STROUT
		call		bdos
		ld			c, D1F_TERM0
		jp			bdos

this_is_msx1:
		ld			a, [0xFCC1]
		ld			[0xFFF7], a

		ld			de, msg_detect_msx1
		ld			c, D1F_STROUT
		call		bdos

		ld			c, D1F_TERM0
		jp			bdos
		ret

msg_version::
		ds			"MAIN-ROM slot patch v1.00\r\n"
		ds			"Copyright (C)2020 HRA!\r\n\r\n$"

msg_detect_msx1::
		ds			"Detect MSX1.\r\n"
		ds			"Copy [FCC1h] --> [FFF7h]\r\n$"

msg_detect_msx2::
		ds			"Detect MSX2 or later.\r\n"
		ds			"No operation.$"
